<?php

namespace STM\Match\Action;

use STM\StmFactory;

/**
 * Test class for MatchAction.
 * Generated by PHPUnit on 2012-07-11 at 14:33:22.
 * @group match_action
 */
class MatchActionTest extends \PHPUnit_Framework_TestCase {

    private $all_actions;

    protected function setUp() {
        $this->all_actions = StmFactory::find()->MatchAction->findAll();
    }

    public function testFind_all() {
        parent::assertTrue(is_array($this->all_actions));
        foreach ($this->all_actions as $action) {            
            parent::assertInstanceOf('\STM\Match\Action\MatchAction', $action);
        }
    }

    public function testFind_by_sport() {
        foreach (StmFactory::find()->Sport->findAll() as $sport) {
            parent::assertTrue(is_array(StmFactory::find()->MatchAction->findBySport($sport)));
        }
    }

    public function testfindById() {
        foreach ($this->all_actions as $action) {            
            parent::assertInstanceOf('\STM\Match\Action\MatchAction', StmFactory::find()->MatchAction->findById($action->getId()));
        }
        parent::assertFalse(StmFactory::find()->MatchAction->findById(' or 1 = 1'));
        parent::assertFalse(StmFactory::find()->MatchAction->findById(null));
    }

    public function testCreate() {
        parent::markTestSkipped('test in MatchActionValidatorTest');
    }

    public function testExists_action() {
        foreach ($this->all_actions as $action) {            
            $name = $action->__toString();
            // case-INsensitive
            parent::assertTrue(MatchAction::exists($name));
            parent::assertTrue(MatchAction::exists(mb_strtolower($name, 'UTF-8')));
            parent::assertTrue(MatchAction::exists(mb_strtoupper($name, 'UTF-8')));
            parent::assertFalse(MatchAction::exists('_*A*_' . $name));
            // argument must be string
            parent::assertFalse(MatchAction::exists($action));
            parent::assertFalse(MatchAction::exists(null));
        }
    }

    public function testDelete() {
        parent::markTestSkipped('in testCan_be_deleted, otherwise only DB fail');
    }

    public function testCan_be_deleted() {
        foreach ($this->all_actions as $action) {
            $arr = $action->toArray();
            if ($arr['count_in_teams'] + $arr['count_in_players'] == 0) {
                parent::assertTrue($action->canBeDeleted());
            } else {
                parent::assertFalse($action->canBeDeleted());
                parent::assertFalse($action->delete());
            }
        }
    }

    public function testUpdate() {
        parent::markTestSkipped('test in MatchActionValidatorTest');
    }

}

?>
